# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ChallengeArgs', 'Challenge']

@pulumi.input_type
class ChallengeArgs:
    def __init__(__self__, *,
                 category: pulumi.Input[str],
                 description: pulumi.Input[str],
                 value: pulumi.Input[int],
                 connection_info: Optional[pulumi.Input[str]] = None,
                 decay: Optional[pulumi.Input[int]] = None,
                 files: Optional[pulumi.Input[Sequence[pulumi.Input['ChallengeFileArgs']]]] = None,
                 flags: Optional[pulumi.Input[Sequence[pulumi.Input['ChallengeFlagArgs']]]] = None,
                 function: Optional[pulumi.Input[str]] = None,
                 hints: Optional[pulumi.Input[Sequence[pulumi.Input['ChallengeHintArgs']]]] = None,
                 max_attempts: Optional[pulumi.Input[int]] = None,
                 minimum: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 next: Optional[pulumi.Input[int]] = None,
                 requirements: Optional[pulumi.Input['ChallengeRequirementsArgs']] = None,
                 state: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 topics: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 type: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Challenge resource.
        :param pulumi.Input[str] category: Category of the challenge that CTFd groups by on the web UI.
        :param pulumi.Input[str] description: Description of the challenge, consider using multiline descriptions for better style.
        :param pulumi.Input[int] value: The value (points) of the challenge once solved. Internally, the provider will handle what target is legitimate depending on the `.type` value, i.e. either `value` for "standard" or `initial` for "dynamic".
        :param pulumi.Input[str] connection_info: Connection Information to connect to the challenge instance, useful for pwn, web and infrastructure pentests.
        :param pulumi.Input[int] decay: The decay defines from each number of solves does the decay function triggers until reaching minimum. This function is defined by CTFd and could be configured through `.function`.
        :param pulumi.Input[Sequence[pulumi.Input['ChallengeFileArgs']]] files: List of files given to players to flag the challenge.
        :param pulumi.Input[Sequence[pulumi.Input['ChallengeFlagArgs']]] flags: List of challenge flags that solves it.
        :param pulumi.Input[str] function: Decay function to define how the challenge value evolve through solves, either linear or logarithmic.
        :param pulumi.Input[Sequence[pulumi.Input['ChallengeHintArgs']]] hints: List of hints about the challenge displayed to the end-user.
        :param pulumi.Input[int] max_attempts: Maximum amount of attempts before being unable to flag the challenge.
        :param pulumi.Input[int] minimum: The minimum points for a dynamic-score challenge to reach with the decay function. Once there, no solve could have more value.
        :param pulumi.Input[str] name: Name of the file as displayed to end-users.
        :param pulumi.Input[int] next: Suggestion for the end-user as next challenge to work on.
        :param pulumi.Input['ChallengeRequirementsArgs'] requirements: Other hints required to be consumed before getting this one. Useful for cost-increasing hint strategies with more and more help.
        :param pulumi.Input[str] state: State of the challenge, either hidden or visible.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tags: List of challenge tags that will be displayed to the end-user. You could use them to give some quick insights of what a challenge involves.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] topics: List of challenge topics that are displayed to the administrators for maintenance and planification.
        :param pulumi.Input[str] type: The type of the flag, could be either static or regex
        """
        pulumi.set(__self__, "category", category)
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "value", value)
        if connection_info is not None:
            pulumi.set(__self__, "connection_info", connection_info)
        if decay is not None:
            pulumi.set(__self__, "decay", decay)
        if files is not None:
            pulumi.set(__self__, "files", files)
        if flags is not None:
            pulumi.set(__self__, "flags", flags)
        if function is not None:
            pulumi.set(__self__, "function", function)
        if hints is not None:
            pulumi.set(__self__, "hints", hints)
        if max_attempts is not None:
            pulumi.set(__self__, "max_attempts", max_attempts)
        if minimum is not None:
            pulumi.set(__self__, "minimum", minimum)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if next is not None:
            pulumi.set(__self__, "next", next)
        if requirements is not None:
            pulumi.set(__self__, "requirements", requirements)
        if state is not None:
            pulumi.set(__self__, "state", state)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if topics is not None:
            pulumi.set(__self__, "topics", topics)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def category(self) -> pulumi.Input[str]:
        """
        Category of the challenge that CTFd groups by on the web UI.
        """
        return pulumi.get(self, "category")

    @category.setter
    def category(self, value: pulumi.Input[str]):
        pulumi.set(self, "category", value)

    @property
    @pulumi.getter
    def description(self) -> pulumi.Input[str]:
        """
        Description of the challenge, consider using multiline descriptions for better style.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: pulumi.Input[str]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def value(self) -> pulumi.Input[int]:
        """
        The value (points) of the challenge once solved. Internally, the provider will handle what target is legitimate depending on the `.type` value, i.e. either `value` for "standard" or `initial` for "dynamic".
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: pulumi.Input[int]):
        pulumi.set(self, "value", value)

    @property
    @pulumi.getter(name="connectionInfo")
    def connection_info(self) -> Optional[pulumi.Input[str]]:
        """
        Connection Information to connect to the challenge instance, useful for pwn, web and infrastructure pentests.
        """
        return pulumi.get(self, "connection_info")

    @connection_info.setter
    def connection_info(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "connection_info", value)

    @property
    @pulumi.getter
    def decay(self) -> Optional[pulumi.Input[int]]:
        """
        The decay defines from each number of solves does the decay function triggers until reaching minimum. This function is defined by CTFd and could be configured through `.function`.
        """
        return pulumi.get(self, "decay")

    @decay.setter
    def decay(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "decay", value)

    @property
    @pulumi.getter
    def files(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ChallengeFileArgs']]]]:
        """
        List of files given to players to flag the challenge.
        """
        return pulumi.get(self, "files")

    @files.setter
    def files(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ChallengeFileArgs']]]]):
        pulumi.set(self, "files", value)

    @property
    @pulumi.getter
    def flags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ChallengeFlagArgs']]]]:
        """
        List of challenge flags that solves it.
        """
        return pulumi.get(self, "flags")

    @flags.setter
    def flags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ChallengeFlagArgs']]]]):
        pulumi.set(self, "flags", value)

    @property
    @pulumi.getter
    def function(self) -> Optional[pulumi.Input[str]]:
        """
        Decay function to define how the challenge value evolve through solves, either linear or logarithmic.
        """
        return pulumi.get(self, "function")

    @function.setter
    def function(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "function", value)

    @property
    @pulumi.getter
    def hints(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ChallengeHintArgs']]]]:
        """
        List of hints about the challenge displayed to the end-user.
        """
        return pulumi.get(self, "hints")

    @hints.setter
    def hints(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ChallengeHintArgs']]]]):
        pulumi.set(self, "hints", value)

    @property
    @pulumi.getter(name="maxAttempts")
    def max_attempts(self) -> Optional[pulumi.Input[int]]:
        """
        Maximum amount of attempts before being unable to flag the challenge.
        """
        return pulumi.get(self, "max_attempts")

    @max_attempts.setter
    def max_attempts(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "max_attempts", value)

    @property
    @pulumi.getter
    def minimum(self) -> Optional[pulumi.Input[int]]:
        """
        The minimum points for a dynamic-score challenge to reach with the decay function. Once there, no solve could have more value.
        """
        return pulumi.get(self, "minimum")

    @minimum.setter
    def minimum(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "minimum", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the file as displayed to end-users.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def next(self) -> Optional[pulumi.Input[int]]:
        """
        Suggestion for the end-user as next challenge to work on.
        """
        return pulumi.get(self, "next")

    @next.setter
    def next(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "next", value)

    @property
    @pulumi.getter
    def requirements(self) -> Optional[pulumi.Input['ChallengeRequirementsArgs']]:
        """
        Other hints required to be consumed before getting this one. Useful for cost-increasing hint strategies with more and more help.
        """
        return pulumi.get(self, "requirements")

    @requirements.setter
    def requirements(self, value: Optional[pulumi.Input['ChallengeRequirementsArgs']]):
        pulumi.set(self, "requirements", value)

    @property
    @pulumi.getter
    def state(self) -> Optional[pulumi.Input[str]]:
        """
        State of the challenge, either hidden or visible.
        """
        return pulumi.get(self, "state")

    @state.setter
    def state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "state", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        List of challenge tags that will be displayed to the end-user. You could use them to give some quick insights of what a challenge involves.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter
    def topics(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        List of challenge topics that are displayed to the administrators for maintenance and planification.
        """
        return pulumi.get(self, "topics")

    @topics.setter
    def topics(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "topics", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        The type of the flag, could be either static or regex
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)


@pulumi.input_type
class _ChallengeState:
    def __init__(__self__, *,
                 category: Optional[pulumi.Input[str]] = None,
                 connection_info: Optional[pulumi.Input[str]] = None,
                 decay: Optional[pulumi.Input[int]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 files: Optional[pulumi.Input[Sequence[pulumi.Input['ChallengeFileArgs']]]] = None,
                 flags: Optional[pulumi.Input[Sequence[pulumi.Input['ChallengeFlagArgs']]]] = None,
                 function: Optional[pulumi.Input[str]] = None,
                 hints: Optional[pulumi.Input[Sequence[pulumi.Input['ChallengeHintArgs']]]] = None,
                 max_attempts: Optional[pulumi.Input[int]] = None,
                 minimum: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 next: Optional[pulumi.Input[int]] = None,
                 requirements: Optional[pulumi.Input['ChallengeRequirementsArgs']] = None,
                 state: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 topics: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 value: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering Challenge resources.
        :param pulumi.Input[str] category: Category of the challenge that CTFd groups by on the web UI.
        :param pulumi.Input[str] connection_info: Connection Information to connect to the challenge instance, useful for pwn, web and infrastructure pentests.
        :param pulumi.Input[int] decay: The decay defines from each number of solves does the decay function triggers until reaching minimum. This function is defined by CTFd and could be configured through `.function`.
        :param pulumi.Input[str] description: Description of the challenge, consider using multiline descriptions for better style.
        :param pulumi.Input[Sequence[pulumi.Input['ChallengeFileArgs']]] files: List of files given to players to flag the challenge.
        :param pulumi.Input[Sequence[pulumi.Input['ChallengeFlagArgs']]] flags: List of challenge flags that solves it.
        :param pulumi.Input[str] function: Decay function to define how the challenge value evolve through solves, either linear or logarithmic.
        :param pulumi.Input[Sequence[pulumi.Input['ChallengeHintArgs']]] hints: List of hints about the challenge displayed to the end-user.
        :param pulumi.Input[int] max_attempts: Maximum amount of attempts before being unable to flag the challenge.
        :param pulumi.Input[int] minimum: The minimum points for a dynamic-score challenge to reach with the decay function. Once there, no solve could have more value.
        :param pulumi.Input[str] name: Name of the file as displayed to end-users.
        :param pulumi.Input[int] next: Suggestion for the end-user as next challenge to work on.
        :param pulumi.Input['ChallengeRequirementsArgs'] requirements: Other hints required to be consumed before getting this one. Useful for cost-increasing hint strategies with more and more help.
        :param pulumi.Input[str] state: State of the challenge, either hidden or visible.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tags: List of challenge tags that will be displayed to the end-user. You could use them to give some quick insights of what a challenge involves.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] topics: List of challenge topics that are displayed to the administrators for maintenance and planification.
        :param pulumi.Input[str] type: The type of the flag, could be either static or regex
        :param pulumi.Input[int] value: The value (points) of the challenge once solved. Internally, the provider will handle what target is legitimate depending on the `.type` value, i.e. either `value` for "standard" or `initial` for "dynamic".
        """
        if category is not None:
            pulumi.set(__self__, "category", category)
        if connection_info is not None:
            pulumi.set(__self__, "connection_info", connection_info)
        if decay is not None:
            pulumi.set(__self__, "decay", decay)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if files is not None:
            pulumi.set(__self__, "files", files)
        if flags is not None:
            pulumi.set(__self__, "flags", flags)
        if function is not None:
            pulumi.set(__self__, "function", function)
        if hints is not None:
            pulumi.set(__self__, "hints", hints)
        if max_attempts is not None:
            pulumi.set(__self__, "max_attempts", max_attempts)
        if minimum is not None:
            pulumi.set(__self__, "minimum", minimum)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if next is not None:
            pulumi.set(__self__, "next", next)
        if requirements is not None:
            pulumi.set(__self__, "requirements", requirements)
        if state is not None:
            pulumi.set(__self__, "state", state)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if topics is not None:
            pulumi.set(__self__, "topics", topics)
        if type is not None:
            pulumi.set(__self__, "type", type)
        if value is not None:
            pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def category(self) -> Optional[pulumi.Input[str]]:
        """
        Category of the challenge that CTFd groups by on the web UI.
        """
        return pulumi.get(self, "category")

    @category.setter
    def category(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "category", value)

    @property
    @pulumi.getter(name="connectionInfo")
    def connection_info(self) -> Optional[pulumi.Input[str]]:
        """
        Connection Information to connect to the challenge instance, useful for pwn, web and infrastructure pentests.
        """
        return pulumi.get(self, "connection_info")

    @connection_info.setter
    def connection_info(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "connection_info", value)

    @property
    @pulumi.getter
    def decay(self) -> Optional[pulumi.Input[int]]:
        """
        The decay defines from each number of solves does the decay function triggers until reaching minimum. This function is defined by CTFd and could be configured through `.function`.
        """
        return pulumi.get(self, "decay")

    @decay.setter
    def decay(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "decay", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of the challenge, consider using multiline descriptions for better style.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def files(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ChallengeFileArgs']]]]:
        """
        List of files given to players to flag the challenge.
        """
        return pulumi.get(self, "files")

    @files.setter
    def files(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ChallengeFileArgs']]]]):
        pulumi.set(self, "files", value)

    @property
    @pulumi.getter
    def flags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ChallengeFlagArgs']]]]:
        """
        List of challenge flags that solves it.
        """
        return pulumi.get(self, "flags")

    @flags.setter
    def flags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ChallengeFlagArgs']]]]):
        pulumi.set(self, "flags", value)

    @property
    @pulumi.getter
    def function(self) -> Optional[pulumi.Input[str]]:
        """
        Decay function to define how the challenge value evolve through solves, either linear or logarithmic.
        """
        return pulumi.get(self, "function")

    @function.setter
    def function(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "function", value)

    @property
    @pulumi.getter
    def hints(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ChallengeHintArgs']]]]:
        """
        List of hints about the challenge displayed to the end-user.
        """
        return pulumi.get(self, "hints")

    @hints.setter
    def hints(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ChallengeHintArgs']]]]):
        pulumi.set(self, "hints", value)

    @property
    @pulumi.getter(name="maxAttempts")
    def max_attempts(self) -> Optional[pulumi.Input[int]]:
        """
        Maximum amount of attempts before being unable to flag the challenge.
        """
        return pulumi.get(self, "max_attempts")

    @max_attempts.setter
    def max_attempts(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "max_attempts", value)

    @property
    @pulumi.getter
    def minimum(self) -> Optional[pulumi.Input[int]]:
        """
        The minimum points for a dynamic-score challenge to reach with the decay function. Once there, no solve could have more value.
        """
        return pulumi.get(self, "minimum")

    @minimum.setter
    def minimum(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "minimum", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the file as displayed to end-users.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def next(self) -> Optional[pulumi.Input[int]]:
        """
        Suggestion for the end-user as next challenge to work on.
        """
        return pulumi.get(self, "next")

    @next.setter
    def next(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "next", value)

    @property
    @pulumi.getter
    def requirements(self) -> Optional[pulumi.Input['ChallengeRequirementsArgs']]:
        """
        Other hints required to be consumed before getting this one. Useful for cost-increasing hint strategies with more and more help.
        """
        return pulumi.get(self, "requirements")

    @requirements.setter
    def requirements(self, value: Optional[pulumi.Input['ChallengeRequirementsArgs']]):
        pulumi.set(self, "requirements", value)

    @property
    @pulumi.getter
    def state(self) -> Optional[pulumi.Input[str]]:
        """
        State of the challenge, either hidden or visible.
        """
        return pulumi.get(self, "state")

    @state.setter
    def state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "state", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        List of challenge tags that will be displayed to the end-user. You could use them to give some quick insights of what a challenge involves.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter
    def topics(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        List of challenge topics that are displayed to the administrators for maintenance and planification.
        """
        return pulumi.get(self, "topics")

    @topics.setter
    def topics(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "topics", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        The type of the flag, could be either static or regex
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[pulumi.Input[int]]:
        """
        The value (points) of the challenge once solved. Internally, the provider will handle what target is legitimate depending on the `.type` value, i.e. either `value` for "standard" or `initial` for "dynamic".
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "value", value)


class Challenge(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 category: Optional[pulumi.Input[str]] = None,
                 connection_info: Optional[pulumi.Input[str]] = None,
                 decay: Optional[pulumi.Input[int]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 files: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ChallengeFileArgs']]]]] = None,
                 flags: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ChallengeFlagArgs']]]]] = None,
                 function: Optional[pulumi.Input[str]] = None,
                 hints: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ChallengeHintArgs']]]]] = None,
                 max_attempts: Optional[pulumi.Input[int]] = None,
                 minimum: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 next: Optional[pulumi.Input[int]] = None,
                 requirements: Optional[pulumi.Input[pulumi.InputType['ChallengeRequirementsArgs']]] = None,
                 state: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 topics: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 value: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        CTFd is built around the Challenge resource, which contains all the attributes to define a part of the Capture The Flag event.

        This provider builds a cleaner API on top of CTFd's one to improve its adoption and lifecycle management.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] category: Category of the challenge that CTFd groups by on the web UI.
        :param pulumi.Input[str] connection_info: Connection Information to connect to the challenge instance, useful for pwn, web and infrastructure pentests.
        :param pulumi.Input[int] decay: The decay defines from each number of solves does the decay function triggers until reaching minimum. This function is defined by CTFd and could be configured through `.function`.
        :param pulumi.Input[str] description: Description of the challenge, consider using multiline descriptions for better style.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ChallengeFileArgs']]]] files: List of files given to players to flag the challenge.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ChallengeFlagArgs']]]] flags: List of challenge flags that solves it.
        :param pulumi.Input[str] function: Decay function to define how the challenge value evolve through solves, either linear or logarithmic.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ChallengeHintArgs']]]] hints: List of hints about the challenge displayed to the end-user.
        :param pulumi.Input[int] max_attempts: Maximum amount of attempts before being unable to flag the challenge.
        :param pulumi.Input[int] minimum: The minimum points for a dynamic-score challenge to reach with the decay function. Once there, no solve could have more value.
        :param pulumi.Input[str] name: Name of the file as displayed to end-users.
        :param pulumi.Input[int] next: Suggestion for the end-user as next challenge to work on.
        :param pulumi.Input[pulumi.InputType['ChallengeRequirementsArgs']] requirements: Other hints required to be consumed before getting this one. Useful for cost-increasing hint strategies with more and more help.
        :param pulumi.Input[str] state: State of the challenge, either hidden or visible.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tags: List of challenge tags that will be displayed to the end-user. You could use them to give some quick insights of what a challenge involves.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] topics: List of challenge topics that are displayed to the administrators for maintenance and planification.
        :param pulumi.Input[str] type: The type of the flag, could be either static or regex
        :param pulumi.Input[int] value: The value (points) of the challenge once solved. Internally, the provider will handle what target is legitimate depending on the `.type` value, i.e. either `value` for "standard" or `initial` for "dynamic".
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ChallengeArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        CTFd is built around the Challenge resource, which contains all the attributes to define a part of the Capture The Flag event.

        This provider builds a cleaner API on top of CTFd's one to improve its adoption and lifecycle management.

        :param str resource_name: The name of the resource.
        :param ChallengeArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ChallengeArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 category: Optional[pulumi.Input[str]] = None,
                 connection_info: Optional[pulumi.Input[str]] = None,
                 decay: Optional[pulumi.Input[int]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 files: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ChallengeFileArgs']]]]] = None,
                 flags: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ChallengeFlagArgs']]]]] = None,
                 function: Optional[pulumi.Input[str]] = None,
                 hints: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ChallengeHintArgs']]]]] = None,
                 max_attempts: Optional[pulumi.Input[int]] = None,
                 minimum: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 next: Optional[pulumi.Input[int]] = None,
                 requirements: Optional[pulumi.Input[pulumi.InputType['ChallengeRequirementsArgs']]] = None,
                 state: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 topics: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 value: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ChallengeArgs.__new__(ChallengeArgs)

            if category is None and not opts.urn:
                raise TypeError("Missing required property 'category'")
            __props__.__dict__["category"] = category
            __props__.__dict__["connection_info"] = connection_info
            __props__.__dict__["decay"] = decay
            if description is None and not opts.urn:
                raise TypeError("Missing required property 'description'")
            __props__.__dict__["description"] = description
            __props__.__dict__["files"] = files
            __props__.__dict__["flags"] = flags
            __props__.__dict__["function"] = function
            __props__.__dict__["hints"] = hints
            __props__.__dict__["max_attempts"] = max_attempts
            __props__.__dict__["minimum"] = minimum
            __props__.__dict__["name"] = name
            __props__.__dict__["next"] = next
            __props__.__dict__["requirements"] = requirements
            __props__.__dict__["state"] = state
            __props__.__dict__["tags"] = tags
            __props__.__dict__["topics"] = topics
            __props__.__dict__["type"] = type
            if value is None and not opts.urn:
                raise TypeError("Missing required property 'value'")
            __props__.__dict__["value"] = value
        super(Challenge, __self__).__init__(
            'ctfd:index/challenge:Challenge',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            category: Optional[pulumi.Input[str]] = None,
            connection_info: Optional[pulumi.Input[str]] = None,
            decay: Optional[pulumi.Input[int]] = None,
            description: Optional[pulumi.Input[str]] = None,
            files: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ChallengeFileArgs']]]]] = None,
            flags: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ChallengeFlagArgs']]]]] = None,
            function: Optional[pulumi.Input[str]] = None,
            hints: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ChallengeHintArgs']]]]] = None,
            max_attempts: Optional[pulumi.Input[int]] = None,
            minimum: Optional[pulumi.Input[int]] = None,
            name: Optional[pulumi.Input[str]] = None,
            next: Optional[pulumi.Input[int]] = None,
            requirements: Optional[pulumi.Input[pulumi.InputType['ChallengeRequirementsArgs']]] = None,
            state: Optional[pulumi.Input[str]] = None,
            tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            topics: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            type: Optional[pulumi.Input[str]] = None,
            value: Optional[pulumi.Input[int]] = None) -> 'Challenge':
        """
        Get an existing Challenge resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] category: Category of the challenge that CTFd groups by on the web UI.
        :param pulumi.Input[str] connection_info: Connection Information to connect to the challenge instance, useful for pwn, web and infrastructure pentests.
        :param pulumi.Input[int] decay: The decay defines from each number of solves does the decay function triggers until reaching minimum. This function is defined by CTFd and could be configured through `.function`.
        :param pulumi.Input[str] description: Description of the challenge, consider using multiline descriptions for better style.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ChallengeFileArgs']]]] files: List of files given to players to flag the challenge.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ChallengeFlagArgs']]]] flags: List of challenge flags that solves it.
        :param pulumi.Input[str] function: Decay function to define how the challenge value evolve through solves, either linear or logarithmic.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ChallengeHintArgs']]]] hints: List of hints about the challenge displayed to the end-user.
        :param pulumi.Input[int] max_attempts: Maximum amount of attempts before being unable to flag the challenge.
        :param pulumi.Input[int] minimum: The minimum points for a dynamic-score challenge to reach with the decay function. Once there, no solve could have more value.
        :param pulumi.Input[str] name: Name of the file as displayed to end-users.
        :param pulumi.Input[int] next: Suggestion for the end-user as next challenge to work on.
        :param pulumi.Input[pulumi.InputType['ChallengeRequirementsArgs']] requirements: Other hints required to be consumed before getting this one. Useful for cost-increasing hint strategies with more and more help.
        :param pulumi.Input[str] state: State of the challenge, either hidden or visible.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tags: List of challenge tags that will be displayed to the end-user. You could use them to give some quick insights of what a challenge involves.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] topics: List of challenge topics that are displayed to the administrators for maintenance and planification.
        :param pulumi.Input[str] type: The type of the flag, could be either static or regex
        :param pulumi.Input[int] value: The value (points) of the challenge once solved. Internally, the provider will handle what target is legitimate depending on the `.type` value, i.e. either `value` for "standard" or `initial` for "dynamic".
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ChallengeState.__new__(_ChallengeState)

        __props__.__dict__["category"] = category
        __props__.__dict__["connection_info"] = connection_info
        __props__.__dict__["decay"] = decay
        __props__.__dict__["description"] = description
        __props__.__dict__["files"] = files
        __props__.__dict__["flags"] = flags
        __props__.__dict__["function"] = function
        __props__.__dict__["hints"] = hints
        __props__.__dict__["max_attempts"] = max_attempts
        __props__.__dict__["minimum"] = minimum
        __props__.__dict__["name"] = name
        __props__.__dict__["next"] = next
        __props__.__dict__["requirements"] = requirements
        __props__.__dict__["state"] = state
        __props__.__dict__["tags"] = tags
        __props__.__dict__["topics"] = topics
        __props__.__dict__["type"] = type
        __props__.__dict__["value"] = value
        return Challenge(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def category(self) -> pulumi.Output[str]:
        """
        Category of the challenge that CTFd groups by on the web UI.
        """
        return pulumi.get(self, "category")

    @property
    @pulumi.getter(name="connectionInfo")
    def connection_info(self) -> pulumi.Output[str]:
        """
        Connection Information to connect to the challenge instance, useful for pwn, web and infrastructure pentests.
        """
        return pulumi.get(self, "connection_info")

    @property
    @pulumi.getter
    def decay(self) -> pulumi.Output[Optional[int]]:
        """
        The decay defines from each number of solves does the decay function triggers until reaching minimum. This function is defined by CTFd and could be configured through `.function`.
        """
        return pulumi.get(self, "decay")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[str]:
        """
        Description of the challenge, consider using multiline descriptions for better style.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def files(self) -> pulumi.Output[Optional[Sequence['outputs.ChallengeFile']]]:
        """
        List of files given to players to flag the challenge.
        """
        return pulumi.get(self, "files")

    @property
    @pulumi.getter
    def flags(self) -> pulumi.Output[Optional[Sequence['outputs.ChallengeFlag']]]:
        """
        List of challenge flags that solves it.
        """
        return pulumi.get(self, "flags")

    @property
    @pulumi.getter
    def function(self) -> pulumi.Output[str]:
        """
        Decay function to define how the challenge value evolve through solves, either linear or logarithmic.
        """
        return pulumi.get(self, "function")

    @property
    @pulumi.getter
    def hints(self) -> pulumi.Output[Optional[Sequence['outputs.ChallengeHint']]]:
        """
        List of hints about the challenge displayed to the end-user.
        """
        return pulumi.get(self, "hints")

    @property
    @pulumi.getter(name="maxAttempts")
    def max_attempts(self) -> pulumi.Output[int]:
        """
        Maximum amount of attempts before being unable to flag the challenge.
        """
        return pulumi.get(self, "max_attempts")

    @property
    @pulumi.getter
    def minimum(self) -> pulumi.Output[Optional[int]]:
        """
        The minimum points for a dynamic-score challenge to reach with the decay function. Once there, no solve could have more value.
        """
        return pulumi.get(self, "minimum")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Name of the file as displayed to end-users.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def next(self) -> pulumi.Output[Optional[int]]:
        """
        Suggestion for the end-user as next challenge to work on.
        """
        return pulumi.get(self, "next")

    @property
    @pulumi.getter
    def requirements(self) -> pulumi.Output[Optional['outputs.ChallengeRequirements']]:
        """
        Other hints required to be consumed before getting this one. Useful for cost-increasing hint strategies with more and more help.
        """
        return pulumi.get(self, "requirements")

    @property
    @pulumi.getter
    def state(self) -> pulumi.Output[str]:
        """
        State of the challenge, either hidden or visible.
        """
        return pulumi.get(self, "state")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        List of challenge tags that will be displayed to the end-user. You could use them to give some quick insights of what a challenge involves.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def topics(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        List of challenge topics that are displayed to the administrators for maintenance and planification.
        """
        return pulumi.get(self, "topics")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the flag, could be either static or regex
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def value(self) -> pulumi.Output[int]:
        """
        The value (points) of the challenge once solved. Internally, the provider will handle what target is legitimate depending on the `.type` value, i.e. either `value` for "standard" or `initial` for "dynamic".
        """
        return pulumi.get(self, "value")

